"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connect = exports.createActions = exports.createAction = void 0;

var _forceArray = _interopRequireDefault(require("force-array"));

var _fantasyLand = _interopRequireDefault(require("fantasy-land"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var rFANTASY = /^fantasy-land\//;

var alias = function alias(c) {
  return Object.getOwnPropertyNames(c).filter(function (n) {
    return rFANTASY.test(n);
  }).map(function (n) {
    return [n.replace(rFANTASY, ''), c[n]];
  });
};

var aliasType = function aliasType(c) {
  alias(c).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        alias = _ref2[0],
        fn = _ref2[1];

    c[alias] = fn;
  });
  alias(c.prototype).forEach(function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        alias = _ref4[0],
        fn = _ref4[1];

    c.prototype[alias] = fn;
  });
  return c;
};

var createAction = function createAction(name) {
  var action = _defineProperty({}, name,
  /*#__PURE__*/
  function () {
    function _class(value) {
      _classCallCheck(this, _class);

      this.__value = value;
      this['@@type'] = name;
    }

    _createClass(_class, [{
      key: _fantasyLand["default"].map,
      value: function value(fn) {
        return action[name].of(fn(this.join()));
      }
    }, {
      key: _fantasyLand["default"].ap,
      value: function value(m) {
        var _this = this;

        return m.chain(function (fn) {
          return _this.map(fn);
        });
      }
    }, {
      key: _fantasyLand["default"].chain,
      value: function value(fn) {
        return fn(this.join());
      }
    }, {
      key: _fantasyLand["default"].equals,
      value: function value(a) {
        return a.join() === this.join();
      }
    }, {
      key: "lift",
      value: function lift(m) {
        return m.map(this.__value);
      }
    }, {
      key: "join",
      value: function join() {
        return this.__value;
      }
    }, {
      key: "unwrapOrElse",
      value: function unwrapOrElse(_default) {
        return typeof this.join() === 'undefined' ? _default : this.join();
      }
    }], [{
      key: _fantasyLand["default"].of,
      value: function value(_value) {
        return new action[name](_value);
      }
    }, {
      key: "of",
      value: function of(value) {
        return new action[name](value);
      }
    }, {
      key: "is",
      value: function is(type) {
        return type instanceof action[name];
      }
    }]);

    return _class;
  }());

  return aliasType(action[name]);
};

exports.createAction = createAction;

var createActions = function createActions(actions) {
  return (0, _forceArray["default"])(actions).filter(_utils.isString).map(createAction);
};

exports.createActions = createActions;

var connect = function connect(signal) {
  return function (actions) {
    return createActions(actions).map(function (Action) {
      Action.of = function (value) {
        var action = new Action(value);
        signal.emit(action);
        return action;
      };

      Action[_fantasyLand["default"].of] = Action.of;
      return Action;
    });
  };
};

exports.connect = connect;